unit Childwin;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
     SysUtils, ComCtrls, ExtRich;

type
  TMDIChild = class(TForm)
    EditMemo: TExtRich;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure EditMemoPosChange(Sender: TObject; Col, Row: Integer);
    procedure EditMemoModeChange(Sender: TObject; InsertMode: Boolean);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses
  Main;

{$R *.DFM}


procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;

  {Erase the panels}
  MainForm.PosPanel.Caption:= '';
  MainForm.ModePanel.Caption:= '';
end;

procedure TMDIChild.FormActivate(Sender: TObject);
begin
  {Get caret position and input mode}
  EditMemo.GetStatus;
end;

procedure TMDIChild.EditMemoPosChange(Sender: TObject; Col, Row: Integer);
begin
  {Write the caret position in the position panel}
  MainForm.PosPanel.Caption:= IntToStr(Row) + ' : ' + IntToStr(Col);
end;

procedure TMDIChild.EditMemoModeChange(Sender: TObject;
  InsertMode: Boolean);
begin
  {Is memo in insert mode..}
  if InsertMode then
    {..then write 'Insert'}
    MainForm.ModePanel.Caption:= 'Insert'
  else
    {..otherwise write 'overwrite'}
    MainForm.ModePanel.Caption:= 'Overwrite';
end;

procedure TMDIChild.FormResize(Sender: TObject);
var
  Index: Integer;
  AllMinimized: Boolean;
begin
  AllMinimized:= True;

  {Check if all childs are minimized}
  for Index:= 0 to MainForm.MDIChildCount - 1 do
  begin
    if ((MainForm.MDIChildren[Index] as TMDIChild).WindowState <> wsMinimized) then
      AllMinimized:= False;
  end;

  {Are all childs are minimized..}
  if AllMinimized then
  begin
    {..then erase all panels}
    MainForm.PosPanel.Caption:= '';
    MainForm.ModePanel.Caption:= '';
  end
  else
    {..otherwise get information from the new active child}
    (MainForm.ActiveMDIChild as TMDIChild).EditMemo.GetStatus;
end;

end.
